SR Policy Extensions for Path Segment and Bidirectional Path
Cheng Li
Huawei Technologies
Huawei Campus, No. 156 Beiqing Rd.
Beijing
100095
China
c.l@huawei.com
Zhenbin Li
Huawei Technologies
Huawei Campus, No. 156 Beiqing Rd.
Beijing
100095
China
lizhenbin@huawei.com
Yuanyang Yin
China Telecom
Guangzhou
China
yinyuany@chinatelecom.cn
Weiqiang Cheng
China Mobile
Beijing
China
chengweiqiang@chinamobile.com
Ketan Talaulikar
Cisco Systems
ketant.ietf@gmail.com
8 August 2022
Routing Area
Interdomain Routing Working Group
A Segment Routing (SR) policy is a set of candidate SR paths consisting of one or more segment lists with necessary path attributes. For each SR path, it may also have its own path attributes, and Path Segment is one of them. A Path Segment is defined to identify an SR path, which can be used for performance measurement, path correlation, and end-2-end path protection. Path Segment can be also used to correlate two unidirectional SR paths into a bidirectional SR path which is required in some scenarios, for example, mobile backhaul transport network.
This document defines extensions to BGP to distribute SR policies carrying Path Segment and bidirectional path information.

Requirements Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in RFC 2119.

Introduction
Segment routing (SR) [RFC8402] is a source routing paradigm that explicitly indicates the forwarding path for packets at the ingress node. The ingress node steers packets into a specific path according to the Segment Routing Policy ( SR Policy) as defined in [RFC9256]. For distributing SR policies to the headend, [RFC9256] specifies a mechanism by using BGP, and new sub-TLVs are defined for SR Policies in BGP UPDATE message.
In many use cases such as performance measurement, the path to which the packets belong is required to be identified. Futhermore, in some scenarios, for example, mobile backhaul transport network, there are requirements to support bidirectional path. However, there is no path identification information for each Segment List in the SR Policies defined in [RFC9256]. Also, the SR Policies defined in [RFC9256] only supports unidirectional SR paths.
Therefore, this document defines the extension to SR policies that carry Path Segment in the Segment List and support bidirectional path. The Path Segment can be a Path Segment in SR-MPLS [I-D.ietf-spring-mpls-path-segment] and SRv6 [I-D.ietf-spring-srv6-path-segment], or other IDs that can identify a path. Also, this document defines extensions to BGP to distribute SR policies carrying Path Segment and bidirectional path information.

Terminology
This memo makes use of the terms defined in [RFC8402] and [RFC9256].

Requirements Language
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.

Path Segment in SR Policy
As defined in [I-D.ietf-idr-segment-routing-te-policy] , the SR Policy encoding structure is as follows:

   SR Policy SAFI NLRI: <Distinguisher, Policy-Color, Endpoint>
   Attributes:
      Tunnel Encaps Attribute (23)
         Tunnel Type: SR Policy
             Binding SID
             Preference
             Priority
             Policy Name
             Explicit NULL Label Policy (ENLP)
             Segment List
                 Weight
                 Segment
                 Segment
                 ...
             ...

An SR path can be specified by an Segment List sub-TLV that contains a set of segment sub-TLVs and other sub-TLVs as shown above. As defined in [RFC9256], a candidate path includes multiple SR paths specified by SID list. The Path Segment can be used for identifying an SR path(specified by SID list) from the headend and the tailend. Also, it can be used for identifying an SR candidate path in some use cases if needed. This document defines a new Path Segment sub-TLV within Segment List sub-TLV, the details will be described at section 3.1. The new SR Policy encoding structure with Path Segmentg sub-TLV is expressed as below:

   SR Policy SAFI NLRI: <Distinguisher, Policy-Color, Endpoint>
   Attributes:
      Tunnel Encaps Attribute (23)
         Tunnel Type: SR Policy
             Binding SID
             Preference
             Priority
             Policy Name
             Explicit NULL Label Policy (ENLP)
             Segment List
                 Weight
                 Path Segment
                 Segment
                 Segment
                 ...
             Segment List
                 Weight
                 Path Segment
                 Segment
                 Segment
                 ...
             ...

The Path Segment is used to identified an SR path, and it can be used in OAM or IOAM use cases. When all the SID Lists within a candidate path share the same Path Segment ID, the Path Segment can be used to collect the aggregated information of the candidate path. Multiple Path Segment MAY be included in a Segment List for different use cases, all of them SHOULD be inserted into the SID List.

SR Path Segment Sub-TLV
This section defines an SR Path Segment sub-TLV.
An SR Path Segment sub-TLV is included in the segment list sub-TLV to identify an SID list. It has the following format:
  0                   1                   2                   3
  0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 |      Type     |    Length     |    Flags      |  RESERVED     |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 |                     Path Segment ID (Variable)                |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 //     SRv6 Endpoint Behavior and SID Structure (optional)     //
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
                    Figure 1. Path Segment sub-TLV

Where:
- Type: to be assigned by IANA.
- Length: the total length of the value field not including Type and Length fields.
- Flags: 8 bits of flags. Following flags are defined:
  0  1  2  3  4  5  6  7
 +--+--+--+--+--+--+--+--+
 |    Reserved     |B |L |
 +--+--+--+--+--+--+--+--+

  - L-Flag: Local flag. Set when the Path Segment has local significance on an SR node.
  - B-Flag: This flag, when set, indicates the presence of the SRv6 Endpoint Behavior and SID Structure encoding specified in Section 2.4.4.2.13 of [I-D.ietf-idr-segment-routing-te-policy]. It MUST be ignored when the value of length field is smaller than 18.
  - The rest bits of Flag are reserved and MUST be set to 0 on transmission and MUST be ignored on receipt.
- Path Segment ID: if the length is 2, then no Path Segment ID is present. If the length is 6 then the Path Segment ID is encoded in 4 octets [I-D.ietf-spring-mpls-path-segment] using the format below. TC, S, TTL (Total of 12 bits) are RESERVED and SHOULD be set to zero and MUST be ignored.
  0                   1                   2                   3
  0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 |      Type     |    Length     |    Flags      |  Reserved     |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 |         Path Segment Label            | TC  |S|       TTL     |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
              Figure 2. SR-MPLS Path Segment sub-TLV

If the length is 18 then the Path Segment ID contains a 16-octet SRv6 Path Segment ID [I-D.ietf-spring-srv6-path-segment].
If the length is larger than 18 and B-flag is set, then SRv6 Endpoint Behavior and SID Structure TLVs [I-D.ietf-idr-segment-routing-te-policy] is included.

SR Policy for Bidirectional Path
In some scenarios, for example, mobile backhaul transport network, there are requirements to support bidirectional path. In SR, a bidirectional path can be represented as a binding of two unidirectional SR paths. This document also defines a Reverse Segment List sub-TLV to describe the reverse path associated with the forward path specified by the Segment List. An SR policy carrying SR bidirectional path information is expressed as below:

    SR Policy SAFI NLRI: <Distinguisher, Policy-Color, Endpoint>
        Attributes: Tunnel Encaps Attribute (23)
        Tunnel Type: SR Policy
            Binding SID
            Preference
            Priority
            Policy Name
            Explicit NULL Label Policy (ENLP)
            Segment List
                Weight
                Path Segment
                Segment
                Segment
                ...
                Reverse Segment List
                    Path Segment
                    Segment
                    Segment
                    ...

Reverse Path Segment List Sub-TLV
A Reverse Path Segment List sub-TLV is defined to specify an SR reverse path associated with the path specified by the Segment List, and it has the following format:
  0                   1                   2                   3
  0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1 2 3 4 5 6 7 8 9 0 1
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 |    Type       |             Length            |   RESERVED    |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
 |                        Sub-TLVs (Variable)                    |
 +-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
           Figure 3. SR Reverse Path Segment List Sub-TLV

where:
Type: TBA.
Length: the total length of the sub-TLVs encoded within the Reverse Path Segment List Sub-TLV not including the Type and Length fields.
RESERVED: 1 octet of reserved bits. SHOULD be unset on transmission and MUST be ignored on receipt.
sub-TLVs, reuse the sub-TLVs in Segment List defined in [I-D.ietf-idr-segment-routing-te-policy].
- One or more mandatory SR Path Segment sub-TLVs that contains the Path Segments of the reverse SR path.
- One or more Segment sub-TLVs to specify the reverse SR path.
The Segment sub-TLVs in the Reverse Path Segment List sub-TLV provides the information of the reverse SR path, which can be used for directing egress BFD peer to use specific path for the reverse direction of the BFD session [I-D.ietf-mpls-bfd-directed] or other applications.

Operations
The document does not bring new operation beyond the description of operations defined in [I-D.ietf-idr-segment-routing-te-policy]. The existing operations defined in [I-D.ietf-idr-segment-routing-te-policy] can apply to this document directly.
Typically but not limit to, the unidirectional or bidirectional SR policies carrying path identification infomation are configured by a controller.
After configuration, the unidirectional or bidirectional SR policies carrying path identification infomation will be advertised by BGP update messages. The operation of advertisement is the same as defined in [I-D.ietf-idr-segment-routing-te-policy], as well as the reception.
The consumer of the unidirectional or bidirectional SR policies is not the BGP process, it can be any applications, such as performance measurement [I-D.gandhi-spring-udp-pm]. The operation of sending information to consumers is out of scope of this document.

IANA Considerations
This document defines new Sub-TLVs in following registries:

Existing Registry: BGP Tunnel Encapsulation Attribute sub-TLVs
This document defines new sub-TLVs in the registry "SR Policy List Sub-TLVs" [I-D.ietf-idr-segment-routing-te-policy] to be assigned by IANA:
     Codepoint   Description                           Reference
     -------------------------------------------------------------
     TBA         Path Segment sub-TLV                  This document
     TBA         Reverse Segment List sub-TLV          This document

Security Considerations
TBA

Contributors

   Mach(Guoyi) Chen
   Huawei Technologies
   Huawei Campus, No. 156 Beiqing Rd.
   Beijing  100095
   China

   Email: Mach.chen@huawei.com

   Jie Dong
   Huawei Technologies
   Huawei Campus, No. 156 Beiqing Rd.
   Beijing  100095
   China

   Email: jie.dong@huawei.com

   James N Guichard
   Futurewei Technologies
   2330 Central Express Way
   Santa Clara
   USA

   Email: james.n.guichard@futurewei.com

   Huanan Chen
   China Telecom
   109 West Zhongshan Ave
   Guangzhou
   China

   Email: chenhuan6@chinatelecom.cn

Acknowledgements
Many thanks to Shraddha Hedge for her detailed review and professional comments.

Normative References

Informative References
[RFC8402]
[RFC9256]
[I-D.ietf-spring-mpls-path-segment]
[I-D.ietf-spring-srv6-path-segment]
[RFC2119]
[RFC8174]
[I-D.ietf-idr-segment-routing-te-policy]
[I-D.ietf-mpls-bfd-directed]
[I-D.gandhi-spring-udp-pm]